/*
	* LU Minimodes Client Script *
*/

w_TeamScore <- GUIWindow();
l_TeamScore <- GUILabel();

w_RoundInfo <- GUIWindow();
l_Limos <- GUILabel();
l_Time <- GUILabel();
l_TargetTime <- GUILabel();
l_Round <- GUILabel();
p_LimoBar <- GUIProgressBar();

w_RoundStats <- GUIWindow();
l_Top1 <- GUILabel();
l_Top2 <- GUILabel();
l_Top3 <- GUILabel();


function onScriptLoad()
{
	local Attack = 0, Defend = 0, Round = 1, Limos = 4, health = 4000.00;
	
	if ( GetScriptData( "RoundStarted" ) )
	{
		Attack = GetScriptData( "Attack_Score" ), Defend = GetScriptData( "Defend_Score" ), 
				Round = GetScriptData( "Protection_Round" ), Limos = GetScriptData( "Limo_Count" );
		local car1 = FindVehicle( 0 ), car2 = FindVehicle( 1 ), car3 = FindVehicle( 2 ), car4 = FindVehicle( 3 ), health = ( car1 ? car1.Health : 0.00 ) + ( car2 ? car2.Health : 0.00 ) +
			( car3 ? car3.Health : 0.00 ) + ( car4 ? car4.Health : 0.00 );
	}
		
	w_TeamScore.Initialize();
	l_TeamScore.Initialize();
	
	w_TeamScore.Pos = VectorScreen( ScreenWidth - 220, ScreenHeight - 130 );

	w_TeamScore.Size = VectorScreen( 200, 30 );
	w_TeamScore.Alpha = 200;
	w_TeamScore.Transparent = true;
	w_TeamScore.Moveable = false;
	w_TeamScore.Titlebar = true;
	w_TeamScore.TitleText = "Team Scores";
	w_TeamScore.Colour = Colour( 10, 10, 10 );
	
	l_TeamScore.Pos = VectorScreen( 5, 5 );
	l_TeamScore.FontName = "Verdana";
	l_TeamScore.FontSize = 10;
	l_TeamScore.TextColour = Colour( 255, 255, 255 );
	
	w_TeamScore.AddLabel( l_TeamScore );
	AddWindowLayer( w_TeamScore );
	SendWindowToBack( w_TeamScore );
	
	l_TeamScore.Text = "Attacking [" + Attack + " - " + Defend + "] Defending";
	
	w_RoundInfo.Initialize();
	l_Limos.Initialize();
	l_Round.Initialize();
	l_Time.Initialize();
	l_TargetTime.Initialize();
	
	w_RoundInfo.Pos = VectorScreen( ScreenWidth - 220, ScreenHeight - 280 );
	w_RoundInfo.Size = VectorScreen( 200, 150 );
	w_RoundInfo.Alpha = 200;
	w_RoundInfo.Transparent = true;
	w_RoundInfo.Moveable = false;
	w_RoundInfo.Titlebar = true;
	w_RoundInfo.TitleText = "Round Info";
	w_RoundInfo.Colour = Colour( 10, 10, 10 );
	
	l_Round.Pos = VectorScreen( 5, 5 );
	l_Round.FontName = "Verdana";
	l_Round.FontSize = 10;
	l_Round.TextColour = Colour( 255, 255, 255 );
	
	l_Limos.Pos = VectorScreen( 5, 25 );
	l_Limos.FontName = "Verdana";
	l_Limos.FontSize = 10;
	l_Limos.TextColour = Colour( 0, 255, 0 );

	p_LimoBar.Pos = VectorScreen( 5, 45 );
	p_LimoBar.Size = ScreenSize( 100, 12 );
	p_LimoBar.Thickness = 2;
	p_LimoBar.MaxValue = 4000.0;
	p_LimoBar.StartColour =  Colour( 255, 0, 0 );
	p_LimoBar.EndColour = Colour( 0, 255, 0 );
		
	l_Time.Pos = VectorScreen( 5, 65 );
	l_Time.FontName = "Verdana";
	l_Time.FontSize = 10;
	l_Time.TextColour = Colour( 255, 255, 255 );
	
	l_TargetTime.Pos = VectorScreen( 5, 85 );
	l_TargetTime.FontName = "Verdana";
	l_TargetTime.FontSize = 10;
	l_TargetTime.TextColour = Colour( 255, 255, 255 );
	
	w_RoundInfo.AddLabel( l_Limos );
	w_RoundInfo.AddLabel( l_Round );
	w_RoundInfo.AddLabel( l_Time );
	w_RoundInfo.AddLabel( l_TargetTime );
	w_RoundInfo.AddProgressBar( p_LimoBar );
	
	l_Time.Visible = false;
	l_TargetTime.Visible = false;
	
	AddWindowLayer( w_RoundInfo );
	SendWindowToBack( w_RoundInfo );
	
	l_Limos.Text = "Limos Remaining: " + Limos;
	l_Round.Text = "Round: " + Round;
	p_LimoBar.Value = health;
	
	w_RoundStats.Initialize();
	l_Top1.Initialize();
	l_Top2.Initialize();
	l_Top3.Initialize();
	
	w_RoundStats.Pos = VectorScreen( ScreenWidth - 420, ScreenHeight - 170 );

	w_RoundStats.Size = VectorScreen( 200, 70 );
	w_RoundStats.Alpha = 200;
	w_RoundStats.Transparent = true;
	w_RoundStats.Moveable = false;
	w_RoundStats.Titlebar = true;
	w_RoundStats.TitleText = "Round Top 3";
	w_RoundStats.Colour = Colour( 10, 10, 10 );
	
	l_Top1.Pos = VectorScreen( 5, 5 );
	l_Top1.FontName = "Verdana";
	l_Top1.FontSize = 10;
	l_Top1.TextColour = Colour( 255, 255, 255 );
	
	l_Top2.Pos = VectorScreen( 5, 25 );
	l_Top2.FontName = "Verdana";
	l_Top2.FontSize = 10;
	l_Top2.TextColour = Colour( 255, 255, 255 );

	l_Top3.Pos = VectorScreen( 5, 45 );
	l_Top3.FontName = "Verdana";
	l_Top3.FontSize = 10;
	l_Top3.TextColour = Colour( 255, 255, 255 );
	
	w_RoundStats.Visible = false;
	
	w_RoundStats.AddLabel( l_Top1 );
	w_RoundStats.AddLabel( l_Top2 );
	w_RoundStats.AddLabel( l_Top3 );
	
	AddWindowLayer( w_RoundStats );
	SendWindowToBack( w_RoundStats );
}

function onClientRender()
{
	local started = GetScriptData( "RoundStarted" );
		
	if ( started ) 
	{
		local time = TicksToTime(), limos = GetScriptData( "Limo_Count" ), StartTicks = GetScriptData( "StartTime" ), CurrentTicks = GetServerTime(), temp = CurrentTicks - StartTicks, round = GetScriptData( "Protection_Round" );
		l_Time.Text = "Time: " + time;
		
		local car1 = FindVehicle( 0 ), car2 = FindVehicle( 1 ), car3 = FindVehicle( 2 ), car4 = FindVehicle( 3 ), health = ( car1 ? car1.Health : 0.00 ) + ( car2 ? car2.Health : 0.00 ) +
			( car3 ? car3.Health : 0.00 ) + ( car4 ? car4.Health : 0.00 );
		
		if ( l_Limos.Text != limos ) l_Limos.Text = "Limos Remaining: " + limos;
		if ( p_LimoBar.Value != health ) p_LimoBar.Value = health;
		
		if ( limos == 4 ) l_Limos.TextColour = Colour( 0, 255, 0 ); /* Green */
		else if ( ( limos == 2 ) || ( limos == 3 ) ) l_Limos.TextColour = Colour( 255, 153, 0 ); /* Orange */
		else if ( limos == 1 ) l_Limos.TextColour = Colour( 255, 0, 0 ); /* Red */
	
		if ( round == 2 )
		{
			if ( temp < GetScriptData( "TargetTime" ) ) l_Time.TextColour = Colour( 0, 255, 0 );
			else l_Time.TextColour = Colour( 255, 0, 0 );
		}
	}
	else if ( w_RoundInfo.Visible ) w_RoundInfo.Visible = false;
}

function onClientRequestSpawn( pClass )
{
	if ( GetScriptData( "ModeLoaded" ) == 0 )
	{
		Message( "You need to wait until there are two or more players!" );
		return 0;
	}
	return 1;
}

function UpdateHUD()
{
	local round = GetScriptData( "Protection_Round" );
	
	w_RoundInfo.Visible = true;
	l_Time.Visible = true;
	l_TargetTime.Visible = false;
	
	l_Limos.Text = "Limos Remaining: 4";
	l_Limos.TextColour = Colour( 0, 255, 0 );
	
	l_Time.Text = "Time: 00:00";
	l_Time.TextColour = Colour( 255, 255, 255 );
	
	l_Round.Text = "Round: " + round;
	p_LimoBar.Value = 0;
	
	if ( round == 2 )
	{
		l_TargetTime.Visible = true;
		l_TargetTime.Text = "Target Time: " + TicksToTarget();
	}
}

function ScoreUpdate()
{
	local Attack = GetScriptData( "Attack_Score" ), Defend = GetScriptData( "Defend_Score" );
	l_TeamScore.Text = "Attacking [" + Attack + " - " + Defend + "] Defending";	
}

function StatsUpdate()
{
	if ( !w_RoundStats.Visible )
	{
		/* Show the stats */
		w_RoundStats.Visible = true;
		l_Top1.Visible = false;
		l_Top2.Visible = false;
		l_Top3.Visible = false;
		
		local name1 = GetScriptData( "FirstName" ), name2 = GetScriptData( "SecondName" ), name3 = GetScriptData( "ThirdName" ), score1 = GetScriptData( "FirstScore" ), score2 = GetScriptData( "SecondScore" ), score3 = GetScriptData( "ThirdScore" );
		if ( GetScriptData( "FirstName" ) )
		{
			l_Top1.Text = "1) " + name1 + " - " + score1;
			l_Top1.Visible = true;
		}
		if ( GetScriptData( "SecondName" ) )
		{
			l_Top2.Text = "2) " + name2 + " - " + score2;
			l_Top2.Visible = true;
		}
		if ( GetScriptData( "ThirdName" ) )
		{
			l_Top3.Text = "3) " + name3 + " - " + score3;
			l_Top3.Visible = true;
		}
		
		if ( !l_Top1.Visible )
		{
			l_Top1.Text = "No high scores!";
			l_Top1.Visible = true;
		}
	}
	else
	{
		/* Hide the stats */
		w_RoundStats.Visible = false;
	}
}

function TicksToTime()
{
	local StartTicks = GetScriptData( "StartTime" ), CurrentTicks = GetServerTime(), temp = CurrentTicks - StartTicks, mins = temp / 60;
	
	if ( mins > 0 ) 
	{
		local remove = mins * 60;
		temp = temp - remove;
		
	}
	if ( mins < 10 ) mins = "0" + mins;
	if ( temp < 10 ) temp = "0" + temp;
	
	return mins + ":" + temp;
}

function TicksToTarget()
{
	local StartTicks = GetScriptData( "TargetTime" ), secs = StartTicks, mins = secs / 60;
	
	if ( mins > 0 ) 
	{
		local remove = mins * 60;
		secs = secs - remove;
		
	}
	if ( mins < 10 ) mins = "0" + mins;
	if ( secs < 10 ) secs = "0" + secs;
	
	return mins + ":" + secs;
}